import java.util.*;
import java.net.*;
import java.io.*;
import java.util.Date;
import java.text.SimpleDateFormat;

public class Meeting{

	private static ArrayList<User> table_User;
	private static SimpleDateFormat parseDate = new SimpleDateFormat("dd/MM/yyyy");

	public static void main(String[] args) throws Exception {
		table_User = new ArrayList<User>();

		String date = "14/03/2019";
		System.out.println(date_validity(parseDate.parse(date)));

		Date d1 = new Date(2019, 3, 21);
		System.out.println(parseDate.format(d1));

		set_t_user();

		ArrayList<MyDate> calendar = get_calendar();

		print_calendar(calendar);

		System.out.println("--------------------------------------------------");
		System.out.println("Voici les utilisateurs entrer :");
		table_User.forEach((u) -> print_user(u));

		System.out.println("--------------------------------------------------");
		System.out.println("Préparation des points géographiques...");
		ArrayList<Location> t_loc = new ArrayList<Location>();
		table_User.forEach((u) -> t_loc.add(u.get_location()));
		System.out.println("Fini");

		City city = new City(t_loc);

		Appointment appointment = new Appointment(calendar);

		System.out.println("--------------------------------------------------");
		System.out.println("Validation des données...");
		System.out.println("Fini");

		System.out.println("--------------------------------------------------");
		System.out.println("Calcul des chemins...");
		System.out.println("Fini");

		System.out.println("--------------------------------------------------");
		System.out.println("Rendus des résultats...");
		System.out.println("Fini");
	}

	/**
	* Print all user data
	* @param user [description]
	*/
	private static void print_user(User user){
		System.out.println("Utilisateur :");
		System.out.println("Coordonées x, y: " + user.get_location().get_x() + ", " + user.get_location().get_y());
		System.out.println("Date possible :");
		user.get_calendar().forEach((d) -> System.out.println(parseDate.format(d.get_date())));
		System.out.println();
	}

	/**
	 * Print all date from a dates table
	 * @param cal ArrayList<MyDate>, array of date
	 */
	private static void print_calendar(ArrayList<MyDate> cal){
		System.out.println("--------------------------------------------------");
		System.out.println("General calendar");
		cal.forEach((d) -> System.out.println(parseDate.format(d.get_date())));
		System.out.println("Fini");
	}

	/**
	* Set all users with:
	* 		their location,
	* 		their calendar
	*/
	private static void set_t_user() throws Exception{
		System.out.println("Bonjour, veuillez entrer les informations utilisateur:");

		boolean end = false;
		Scanner sc = new Scanner(System.in);
		while(!end){

			System.out.println("Position x:");
			float posx = Float.parseFloat(sc.nextLine());
			System.out.println("Position y:");
			float posy = Float.parseFloat(sc.nextLine());
			System.out.println("Vous avez saisi : " + posx + ", " + posy);

			ArrayList<MyDate> t_date = set_date();

			new_user(posx, posy, t_date);

			if(table_User.size() >= 2){
				System.out.println("--------------------------------------------------");
				System.out.println("Avez-vous fini d'entrer les utilisateurs ? (y/n)");
				if(sc.nextLine().equals("y"))
					end = true;
			}
		}
	}

	/**
	* Set table of date's user
	* @return ArrayList of date
	*/
	private static ArrayList<MyDate> set_date() throws Exception{
		ArrayList<MyDate> t_date = new ArrayList<MyDate>();

		boolean end = false;
		Scanner sc = new Scanner(System.in);
		while(!end){
			System.out.println("Date possible (jour/mois/année heure:min heure:min):");
			String[] line = sc.nextLine().split(" ");

			if(line.length == 3){
				//String[] date = line[0].split("/");

				String[] from = line[1].split(":");
				String[] to = line[2].split(":");

				System.out.println("Vous avez saisi : " + line[0] + " de " +
														from[0] + ":" + from[1] + " à " +
														to[0] + ":" + to[1]);

				MyDate d = new MyDate(parseDate.parse(line[0]),
													new int[]{Integer.parseInt(from[0]), Integer.parseInt(from[1])},
													new int[]{Integer.parseInt(to[0]), Integer.parseInt(to[1])});

				t_date.add(d);
				//calendar.add(d);
				//
				System.out.println("--------------------------------------------------");
				System.out.println("Avez-vous entrer toutes les t_date ? (y/n)");
				if(sc.nextLine().equals("y"))
				end = true;
			}else{
				System.out.println("La date doit être entrée comme montré.");
			}
		}

		return t_date;
	}

	/**
	* Create and add a new user in the table
	* @param posx [description]
	* @param posy [description]
	* @param d    [description]
	*/
	private static void new_user(float posx, float posy, ArrayList<MyDate> d){
		User u = new User(posx, posy, d);
		table_User.add(u);
	}

	/**
	 * Concat all user's calendar
	 * @return ArrayList<MyDate>, calendar of date
	 */
	private static ArrayList<MyDate> get_calendar(){
		ArrayList<MyDate> calendar = new ArrayList<MyDate>();

		for(User u: table_User)
			calendar.addAll(u.get_calendar()); // concat ArrayList

		return calendar;
	}

	private static Boolean date_validity(Date d1){
		Boolean error = false;

		Date d2 = new Date(); // this object contains the current date value


		//Date date = new SimpleDateFormat("dd/MM/yyyy").parse(d1);
    return d2.before(d1);

	}
/*
	private static int[] get_current_date(){
		Date currentDate = new Date(); // this object contains the current date value
		SimpleDateFormat formatter = new SimpleDateFormat("dd/MM/yyyy");
		System.out.println(formatter.format(currentDate));

		String[] tmp = formatter.format(currentDate).split("-");
		int[] date = {0,0,0};

		for(int i = 0; i < tmp.length(); i++){
			date[i] = tmp[i];
		}

		return date;
	}*/
}
